#ifndef MASH_OTCL_MPLUG_H
#define MASH_OTCL_MPLUG_H

#include "tclcl.h"
#include "misc/all-types.h"


class MPlugClient : public TclObject {
public:
	MPlugClient();
	~MPlugClient();

	static int object(int argc, const char * const *argv);
	static int Init(Tcl_Interp *interp);
	
	int dispatch(int argc, const char * const *argv);

private:
	void object(const char *name);

	enum MPlugClientState { mpcNumElems, mpcLen, mpcString };
	
	u_int32_t bytesExpected_;
	u_int32_t numElems_, gotElems_;
	MPlugClientState state_;
	char buf_[256], *buf_ptr_;
	Tcl_Obj **objv_;
	
	Tcl_Obj *mplug_;
	static MPlugClient *instance_;
};





#endif /* MASH_OTCL_MPLUG_H */
